/******************************************************
* Copyright (c):   2004, All Rights Reserved.
* Project:         CS 297 Deliverable 1 N-gram Word Predictor
* File:            DialogNgram.cpp
* Purpose:         The input dialog.
* Start date:      8/30/2004
* Programmer:      Leo Lee
*
*******************************************************/

#include "stdafx.h"
#include "NgramWordPredictor.h"
#include "DialogNgram.h"
#include "NgramWordPredictorDoc.h"
#include "NgramWordPredictorView.h"

// CDialogNgram dialog

IMPLEMENT_DYNAMIC(CDialogNgram, CDialog)

/*****************************************************************************/

CDialogNgram::CDialogNgram(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogNgram::IDD, pParent)
{
	m_pview = (CNgramWordPredictorView*)pParent;
}

/*****************************************************************************/

CDialogNgram::~CDialogNgram()
{
}

/*****************************************************************************/

void CDialogNgram::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_N_SELECT, m_nSelect);
	DDX_Control(pDX, IDC_TEXTAREA, m_text);
	DDX_Control(pDX, IDC_NEXT_WORD, m_nextWord);
}

BEGIN_MESSAGE_MAP(CDialogNgram, CDialog)


	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_LEARN_BUTTON, OnBnClickedLearnButton)
	ON_LBN_SELCHANGE(IDC_N_SELECT, OnLbnSelchangeNSelect)
END_MESSAGE_MAP()

/*****************************************************************************/

int CDialogNgram::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  Add your specialized creation code here

	return 0;
}

/*****************************************************************************/

BOOL CDialogNgram::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Code depends on this numerical ordering
	m_nSelect.AddString("1");
	m_nSelect.AddString("2");
	m_nSelect.AddString("3");
	m_nSelect.AddString("4");
	m_nSelect.AddString("5");

	m_nSelect.SetCurSel(2);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

/*****************************************************************************/

void CDialogNgram::OnBnClickedLearnButton()
{
	((CNgramWordPredictorDoc*)m_pview->GetDocument())->learn(this);
}

/*****************************************************************************/

void CDialogNgram::updatePrediction()
{
	CString predictedWord = ((CNgramWordPredictorDoc*)m_pview->GetDocument())->predict(this);
	m_nextWord.SetWindowText(predictedWord);
	UpdateData(FALSE);
}

/*****************************************************************************/

void CDialogNgram::OnLbnSelchangeNSelect()
{
	((CNgramWordPredictorDoc*)m_pview->GetDocument())->clearModel();
	((CNgramWordPredictorDoc*)m_pview->GetDocument())->learn(this);
}
