// Ngram Word PredictorDoc.h : interface of the CNgramWordPredictorDoc class
//


#pragma once

class CNgramLearner;
class CNgramPredictor;
class CNgramNode;

#include "DialogNgram.h"

class CNgramWordPredictorDoc : public CDocument
{
protected: // create from serialization only
	CNgramWordPredictorDoc();
	DECLARE_DYNCREATE(CNgramWordPredictorDoc)

// Attributes
public:
	static const char* DELIMITERS;

private:
	CNgramNode *m_pmodel;
	CNgramLearner *m_plearner;
	CNgramPredictor *m_ppredictor;

// Operations
public:
	void learn(CDialogNgram *pinputDialog);
	CString predict(CDialogNgram *pinputDialog);
	CNgramNode *getModel() {return m_pmodel;}
	void clearModel();

// Overrides
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

// Implementation
public:
	virtual ~CNgramWordPredictorDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
};
